<!doctype html>
<html lang="de">
	<head>
		<meta charset="utf-8" />
		<title>WED1 - AJAX &amp; Template Engine: Übung 2 Template Engine</title>
		<link rel="icon" href="../HSR.Template.Exercises/icon-document.png" type="image/png">

		<link rel="stylesheet" type="text/css" href="../HSR.Template.Exercises/documentStyle.css">
		<script src="../HSR.Template.Exercises/solutions.js"></script>
		<script src="https://cdn.rawgit.com/google/code-prettify/master/loader/run_prettify.js"></script>

		<style>
			.important-code {
			 	font-size: 1.25em; padding: 0.5em 0; display: inline-block; background: white;
			}
		</style>
	</head>
	<body>
		<h1>
			<a class="backlink" href="../index.html">⇦</a>
			WED1 - AJAX &amp; Template Engine: Übung 2 Template Engine
			<button id="showSolutions">Lösungen anzeigen/ausblenden</button>
		</h1>
		
		<p>In dieser Übung werden Sie den Umgang mit <a href="http://handlebarsjs.com/" target="_blank">Handlebars
		</a> erlernen.</p>


		<h2>Theorie</h2>
		<ul>
			<li>Informationen über Handlebars finden Sie unter <a href="http://handlebarsjs.com/reference.html"
					target="_blank">http://handlebarsjs.com/reference.html</a>.
			</li>
			<li>Ein Tutorial über das Templating-Framework
				finden Sie unter <a href="http://code.tutsplus.com/tutorials/an-introduction-to-handlebars--net-27761"
						target="_blank">http://code.tutsplus.com/</a>.
			</li>
		</ul>


		<h2>Handlebars Einführung</h2>

		<p>Arbeiten Sie das <strong>Basics Chapter</strong> des oben angegebenen Tutorials durch (ohne Custom
			Helpers) und
			bearbeiten Sie im Anschluss die Fragen zum folgenden <a name="books-json">JSON</a>:
		</p>
		<pre class="prettyprint"><code class="language-javascript" style="background: white;"><!--
-->{
	books: [
		{ 'title': 'XML Developer\'s Guide', 'genre' : 'Computer', 'price': 44.95 },
		{ 'title': 'Midnight Rain', 'genre' : 'Fantasy', 'price': 5.95 },
		{ 'title': 'Maeve Ascendant', 'genre' : 'Fantasy', 'price': 5.95 },
		{ 'title': 'Splish Splash', 'genre' : 'Romance', 'price': 4.95 }
	]
}<!--
		-->	</code></pre>
		<p>
			<strong>Tipp</strong>: Falls Sie unsicher sind, wie Handlebars anzuwenden ist, können Sie die <a
			href="vorlagen/vorlage1.html">Vorlage1</a> verwenden.
			Alternativ können Sie den Code auch selbst direkt in eine Seite einbinden, mehr dazu siehe Kapitel Setting up a Handlebars project im Tutorial oben.
		</p>
		<ol>
			<li>
				Wie können Sie in einem Template eine Bedingung setzen, welche bei einer leeren/nicht verfügbaren books-Liste den Text "keine Bücher gefunden" darstellt?

				<div class="solution">
					<pre class="prettyprint"><code class="language-html" style="background: white;"><!--
-->{{#if books}}
	&lt;p&gt;{{books.length}} Bücher vorhanden&lt;/p&gt;
{{else}}
	&lt;p&gt;keine Bücher gefunden&lt;/p&gt;
{{/if}<!--
					--></code></pre>
				</div>
			</li>
			<li>
				Listen Sie alle Bücher in einer Tabelle mit der Überschrift Titel, Genre, Preis.

				<div class="solution">
					<pre class="prettyprint"><code class="language-html" style="background: white;"><!--
-->&lt;table&gt;
	&lt;tr&gt;
		&lt;th&gt;Titel&lt;/th&gt;
		&lt;th&gt;Genre&lt;/th&gt;
		&lt;th&gt;Preis&lt;/th&gt;
	&lt;/tr&gt;
	{{#each books}}
		&lt;tr&gt;
			&lt;td&gt;{{title}}&lt;/td&gt;
			&lt;td&gt;{{genre}}&lt;/td&gt;
			&lt;td&gt;{{price}}&lt;/td&gt;
		&lt;/tr&gt;
	{{/each}}
&lt;/table><!--
				--></code></pre>
				</div>
			</li>
			<li>
				Analysieren Sie den Code in der Vorlage <a href="vorlagen/vorlage1.html" target="_blank">handlebars-vorlage1.html</a>. Warum gibt die Methode <code>Handlebars.compile()</code> eine
				 Funktion zurück?

				<div class="solution">
					<p>Die Compile-Funktion transformiert den "text" in eine (komplexe) Funktion. Diese Transformation müsste ohne Compile jedesmal durchgeführt werden. Somit kann das Template ohne Zeitverlust mehrfach verwendet werden.</p>
				</div>
			</li>
			<li>
				Erweitern Sie die Vorlage wie folgt: <code>Handlebars.compile()</code> soll den Inhalt aus einem
				"template"-Tag verwenden.

				<div class="solution">
					<p>Siehe <a href="solution/solution1.html" target="_blank">Solution1</a></p>
				</div>
			</li>
		</ol>


		<h2>Templating mit Handlebars</h2>
		<ol>
			<li>
				Gehen Sie von <a href="./vorlagen/vorlage2.html" target="_blank">Vorlage2</a> aus. Erweitern
				Sie den
				Code so,
				dass dieser alle 2 Sekunden die Daten vom Server abruft und mittels Handlebars rendert (siehe TODO). Beachten Sie dabei die vorgegebene Funktion <code>server.getData(function(books) {...})</code> und nehmen Sie diese als Blackbox an, welche in der angegebenen Closure Daten (Bücher) vom Server liefert.
				<br /><strong>Tipp</strong>: Verwenden Sie die JavaScript Functions setInterval / setTimeout.

				<div class="solution">
					<p>Bitte fügen Sie den folgenden Code an der TODO-Stelle in der Vorlage ein.</p>
					<pre class="prettyprint"><code class="language-javascript"
					style="background: white;"><!--
-->$(function() {
	// TODO Implementieren Sie hier...
	window.setInterval(function() { server.getData(renderHTML); }, 2000);
});
					</code></pre>
				</div>
			</li>
			<li>Beachten Sie bei Ihrer Implementation, dass der getData()-Aufruf länger als 2 Sekunden dauern kann. Es sollte aber trotzdem nur ein Request zum Server stattfinden.


				<div class="solution">
					<p>Bitte fügen Sie den folgenden Code an der TODO-Stelle in der Vorlage ein.</p>
					<pre class="prettyprint"><code class="language-javascript" style="background: white;"><!--
-->function getDataFromServer() {
	window.setTimeout(function() {
		server.getData(function(books) {
			renderHTML(books);
			getDataFromServer();
		})
	}, 2000);
}
getDataFromServer();<!--
					--></code></pre>
				</div>
			</li>
			<li>Stellen Sie sicher, dass beim ersten Aufruf der Seite bereits Inhalte auf der Page erscheinen.

			<div class="solution">
				<p>Bitte fügen Sie den folgenden Code an der TODO-Stelle in der Vorlage ein.</p>
				<pre class="prettyprint"><code class="language-javascript" style="background: white;"><!--
-->function pollDataFromServer() {
	window.setTimeout(getDataFromServer, 2000);
}

function getDataFromServer() {
	server.getData(function(books) {
		renderHTML(books);
		pollDataFromServer();
	});
}
getDataFromServer();<!--
					--></code></pre>
				</div>
			</li>
		</ol>
		<div class="solution">
			<p>Siehe <a href="solution/solution2.html" target="_blank">Solution2</a></p>
		</div>


		<p>
			<img data-type="icon-difficult" src="../HSR.Template.Exercises/mind.svg" />
			Sehen Sie bei der Auslagerung der Datenanbindung (z.B. über ein simuliertes Server-Objekt wie in der Aufgabe B) konkrete Vorteile?

			<div class="solution">
				<ul>
					<li>Die Auslagerung ermöglicht paralleles Arbeiten; der Client kann unabhängig vom Server entwickelt und getestet werden.</li>
					<li>Der Code ist spezialisierter; die Aufrufe des Server sind an einer Stelle gekapselt.</li>
					<li>Das Vorgehen entspricht dem Layers pattern nach POSA1; das Server-Objekt könnte dem <i>Data Layer</i> entsprechen.</li>
				</ul>
			</div>
		</p>


		<h2>Ponderal-Index-Rechner</h2>
		<p>
			Bei der folgenden Aufgabe sollen Sie einen Ponderal-Index-Rechner implementieren. Als
			Berechnungsschnittstelle benutzen Sie den vorgegebenen Node.js-Server. Wie die Schnittstelle funktioniert
			entnehmen Sie dem <a href="./Ponderal-Index-Rechner/README.md" target="_blank">README</a>.
		</p>
		<figure>
			<video controls width="720" height="480">
				<source src="media/ponderal-calculator.ogg" type="video/ogg" />
				<source src="media/ponderal-calculator.mp4" type="video/mp4" />
			</video>
			<figcaption>Funkionsdemonstration:
				<a href="media/ponderal-calculator.ogg">media/ponderal-calculator.ogg</a> /
				<a href="media/ponderal-calculator.mp4">media/ponderal-calculator.mp4</a>
			</figcaption>
		</figure>

		<ol>
			<li>Installieren Sie die Abhängigkeiten des Servers mittels npm und starten Sie ihn, analog dem Server der
			 AJAX-Aufgaben. Öffnen Sie <a href="http://localhost:8050/template" target="_blank">http://localhost:8050/template</a> im Browser.</li>
			<li>
				<a href="Ponderal-Index-Rechner/app/template/scripts/helpers.js">Ponderal-Index-Rechner/app/template/scripts/helpers.js</a>:
			Implementieren Sie drei Handlebars-Helper um Vergleiche durchführen zu können. Wandeln Sie die
			Parameter jeweils in Zahlen um, damit sie korrekt vergleichen können &rArr; <code>Number(base)</code>.

				<div class="solution">
					<p>helpers.js:</p>
					<pre class="prettyprint"><code class="language-javascript" style="background: white;"><!--
-->Handlebars.registerHelper('between', function(base, value1, value2, options) {
	return (Number(base) > Number(value1) && Number(base) < Number(value2)) ? options.fn(this) : options.inverse(this);
});

Handlebars.registerHelper('lower', function(value1, value2, options) {
	return (Number(value1) < Number(value2)) ? options.fn(this) : options.inverse(this);
});

Handlebars.registerHelper('greater', function(value1, value2, options) {
	return (Number(value1) > Number(value2)) ? options.fn(this) : options.inverse(this);
});<!--
				--></code></pre>
				</div>
			</li>
			<li>Ergänzen Sie die beiden Templates <a href="Ponderal-Index-Rechner/app/template/templates/form.html"
			target="_blank">form.html</a> und <a href="Ponderal-Index-Rechner/app/template/templates/result.html" target="_blank">result.html</a>.
			Nutzen Sie für das Formular passende
			Input-Typen und setzen Sie "Step". Laden Sie als Default-Werte die Werte aus der "config". Dem Benutzer
			soll als Resultat sein Gewicht, seine Grösse und sein Ponderal Wert angezeigt werden. Ist dieser über
			oder unter den Schwellenwerten von 14 und 11, so soll "too much" oder "too less" in rot angezeigt werden,
			ansonsten "is ok" in grün. Nutzen Sie dazu die vorgegebenen CSS-Klassen (<a
			href="Ponderal-Index-Rechner/app/styles/styles.css" target="_blank">styles.css</a>).<br />
			Zeigen Sie dem Benutzer auch eine Tabelle mit seinen persönlichen Schwellwerten an, die die API mitliefert.
			Die entsprechende Zeile seiner Gewichtsklasse soll fett/kursiv dargestellt werden. Nutzen Sie auch hier die
			vorgegebene CSS-Klasse.
			Benutzen Sie die erstellen Handlebars-Helper wo sinnvoll.


				<div class="solution">
					<p>Siehe <a href="Ponderal-Index-Rechner/app/solution/templates/form.html" target="_blank">form.html</a> und
					 <a
					href="Ponderal-Index-Rechner/app/solution/templates/result.html" target="_blank">result.html</a>.
					</p>
				</div>
			</li>
			<li>Implementieren Sie die Logik für das Laden und rendern des Templates in "rechner.js". Laden Sie das
			 Template mit jQuery, kompilieren und rendern Sie es mit Handlebars und fügen Sie es in den
			 Appcontainer ein. Schicken Sie die Formulardaten per AJAX als JSON and die API. Zum Umwandeln der
			 Formulardaten in ein Objekt können Sie die vorgegebene Funktion "serializeFormToObject()" benutzen, da
			 form.serialize() die Formulardaten URL-String-Codiert. Rendern Sie die Resultat-View mit den
			 erhaltenen Daten.

				<div class="solution">
					<pre class="prettyprint"><code class="language-javascript" style="background: white;"><!--
-->$(document).ready(function(){
	var appContainer = $('#app-container');

	function applyTemplate(templateSource, data) {
		var template = Handlebars.compile(templateSource);
		var view = template(data);
		appContainer.html(view);
	}

	function renderResult(data) {
		$.get(config.resultTemplateUrl, function(resultTemplateSource) {
			applyTemplate(resultTemplateSource, data);
		});
	}

	function submitForm(event) {
		var formData = serializeFormToObject($(event.target));
		$.ajax({
			type: 'POST',
			url: config.apiUrl,
			data: JSON.stringify(formData),
			contentType: "application/json",
			dataType: 'json'
		})
		.done(renderResult);

		event.preventDefault();
	}

	$.get(config.formTemplateUrl, function(formTemplateSource) {
		applyTemplate(formTemplateSource, config);
		$('#ponderal-form').on('submit', submitForm);
	});
});<!--
				--></code></pre>
				</div>

				<div class="solution">
					<p>Komplette Lösung, Siehe <a href="./Ponderal-Index-Rechner/app/solution/">
					Ponderal-Index-Rechner/app/solution</a>,
					<a href="http://localhost:8050/solution" target="_blank">http://localhost:8050/solution</a></p>
				</div>
			</li>
			<li>Wie würde "rechner.js" ohne jQuery aussehen? Passen Sie so wenig wie möglich an.

				<div class="solution">
					<pre class="prettyprint"><code class="language-javascript" style="background: white;"><!--
-->document.addEventListener('DOMContentLoaded', function() {
	var appContainer = document.getElementById('app-container');

	function applyTemplate(templateSource, data) {
		var template = Handlebars.compile(templateSource);
		var view = template(data);
		appContainer.innerHTML = view;
	}

	function renderResult(data) {
		var resultRequest = new XMLHttpRequest();
		resultRequest.onreadystatechange = function() {
			if (resultRequest.readyState == 4 && resultRequest.status == 200) {
				applyTemplate(resultRequest.responseText, data);
			}
		};
		resultRequest.open('GET', config.resultTemplateUrl);
		resultRequest.send();
	}

	function submitForm(event) {
		var formData = {
			weight: document.getElementById('weight').value,
			height: document.getElementById('height').value
		};

		var apiRequest = new XMLHttpRequest();
		apiRequest.onreadystatechange = function() {
			if (apiRequest.readyState == 4 && apiRequest.status == 200) {
				var data = JSON.parse(apiRequest.responseText);
				renderResult(data);
			}
		};
		apiRequest.open('POST', config.apiUrl);
		apiRequest.setRequestHeader("Content-Type", "application/json");
		apiRequest.send(JSON.stringify(formData));

		event.preventDefault();
	}

	var formRequest = new XMLHttpRequest();
	formRequest.onreadystatechange = function() {
		if (formRequest.readyState == 4 && formRequest.status == 200) {
			applyTemplate(formRequest.responseText, config);
			var form = document.getElementById('ponderal-form');
			form.addEventListener('submit', submitForm);
		}
	};
	formRequest.open('GET', config.formTemplateUrl);
	formRequest.send();
});<!--
				--></code></pre>
				</div>
			</li>
		</ol>
	</body>
</html>
